// PreviewWnd.cpp : implementation file
//

#include "stdafx.h"
#include "plasma.h"
#include "PreviewWnd.h"
#include "math.h"

extern CPlasmaApp theApp ;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CPreviewWnd

CPreviewWnd::CPreviewWnd()
{
	m_iTimer = 0 ;
	
	srand(::GetTickCount()) ;

	angle1 = 0 ;
	angle2 = 0 ;
	angle3 = 0 ;
	angle4 = 0 ;
	angle5 = 0 ;
	angle1bak = 0 ;
	angle2bak = 0 ;
	angle3bak = 0 ;
	angle4bak = 0 ;
	angle5bak = 0 ;


}

CPreviewWnd::~CPreviewWnd()
{
}


BEGIN_MESSAGE_MAP(CPreviewWnd, CWnd)
	//{{AFX_MSG_MAP(CPreviewWnd)
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPreviewWnd message handlers

BOOL CPreviewWnd::Create(HWND hParentWnd) 
{
    BOOL bRes ;

	RECT parentRect ;

	// Register a class with no cursor

    const char* pszClassName 
        = AfxRegisterWndClass(CS_SAVEBITS, 0, 0 );

    // Create the window
#ifdef _DEBUG
	bRes = CWnd::CreateEx(0 , // WS_EX_TOPMOST,
                          pszClassName,
                          "",
                          WS_POPUP | WS_VISIBLE,
                          0 , 0 , 
						  300 , 200 ,
                          NULL,
                          0);
#else
	::GetClientRect(hParentWnd , &parentRect);

    bRes = CWnd::CreateEx(0 , // WS_EX_TOPMOST,
                          pszClassName,
                          "",
                          WS_CHILD | WS_VISIBLE,
                          0 , 0 , 
						  parentRect.right , parentRect.bottom ,
                          hParentWnd,
                          0);
#endif

	if ( bRes ) 
	{
	   m_iTimer = SetTimer(1, 1000 / frameRate , NULL);
	}

	return bRes ;
	
}


BOOL CPreviewWnd::DestroyWindow() 
{
	if (m_iTimer != 0 ) 
	{
		KillTimer(1);
	}
	
	return CWnd::DestroyWindow();
}

void CPreviewWnd::PostNcDestroy() 
{
	delete this ;
	
	CWnd::PostNcDestroy();
}

BOOL CPreviewWnd::OnEraseBkgnd(CDC* pDC) 
{
	RECT winSize ;

	pDC->GetClipBox( &winSize) ;

	pDC->FillSolidRect ( &winSize , RGB(0,0,0) ) ;	

	// start the plasma sequence

	return TRUE ;
}

int CPreviewWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// create the fixed size DIB

	CDC * pDC ;

	int colourTable[256] ;

	// set up RGB colour table 

	// Use the palette from the PLASMA demo

	int i ;
	for ( i = 0 ; i < 256 ; i++ ) 
		colourTable[i] = 0 ;

	colourTable[75] = RGB (239,227,227);
	colourTable[76] = RGB (243,231,231) ;
	colourTable[77] = RGB (247,239,239) ;
	colourTable[78] = RGB (251,247,247) ;
	colourTable[79] = RGB (255,255,255) ;
	colourTable[80] = RGB (243,247,247);
	colourTable[81] = RGB (231,243,239);
	colourTable[82] = RGB (223,239,231);
	colourTable[83] = RGB (215,235,223) ;
	colourTable[84] = RGB (207,231,215) ;
	colourTable[85] = RGB (195,227,211);
	colourTable[86] = RGB (187,223,203);
	colourTable[87] = RGB (179,215,195);
	colourTable[88] = RGB (171,211,191);
	colourTable[89] = RGB (163,207,183);
	colourTable[90] = RGB (155,203,179);
	colourTable[91] = RGB (147,199,171);
	colourTable[92] = RGB (139,195,163);
	colourTable[93] = RGB (135,191,159);
	colourTable[94] = RGB (127,183,151);
	colourTable[95] = RGB (119,179,147);
	colourTable[96] = RGB (111,175,139);
	colourTable[97] = RGB (107,171,135);
	colourTable[98] = RGB (99,167,131);
	colourTable[99] = RGB (91,163,123);
	colourTable[100] = RGB(87,159,119);
	colourTable[101] = RGB(83,151,111);
	colourTable[102] = RGB(75,147,107);
	colourTable[103] = RGB(71,143,103);
	colourTable[104] = RGB(63,139,99);
	colourTable[105] = RGB(59,135,95);
	colourTable[106] = RGB(55,131,87);
	colourTable[107] = RGB(51,127,83);
	colourTable[108] = RGB(47,119,79);
	colourTable[109] = RGB(43,115,75);
	colourTable[110] = RGB(39,111,71);
	colourTable[111] = RGB(35,107,67);
	colourTable[112] = RGB(31,103,63);
	colourTable[113] = RGB(27,99,59);
	colourTable[114] = RGB(23,95,55);
	colourTable[115] = RGB(19,87,51);
	colourTable[116] = RGB(15,83,47);
	colourTable[117] = RGB(15,79,43);
	colourTable[118] = RGB(11,75,39);
	colourTable[119] = RGB(11,71,35);
	colourTable[120] = RGB(7,67,35);
	colourTable[121] = RGB(7,63,31);
	colourTable[122] = RGB(7,55,27);
	colourTable[123] = RGB(0,51,23);
	colourTable[124] = RGB(0,47,23);
	colourTable[125] = RGB(0,43,19);
	colourTable[126] = RGB(0,39,15);
	colourTable[127] = RGB(0,35,15);
	colourTable[128] = RGB(0,35,15);
	colourTable[129] = RGB(0,39,15);
	colourTable[130] = RGB(0,43,15);
	colourTable[131] = RGB(0,47,15);
	colourTable[132] = RGB(0,51,19);
	colourTable[133] = RGB(0,55,19);
	colourTable[134] = RGB(0,59,19);
	colourTable[135] = RGB(7,59,19);
	colourTable[136] = RGB(7,63,19);
	colourTable[137] = RGB(7,67,19);
	colourTable[138] = RGB(7,71,19);
	colourTable[139] = RGB(11,75,19);
	colourTable[140] = RGB(11,79,23);
	colourTable[141] = RGB(11,83,23);
	colourTable[142] = RGB(15,87,23);
	colourTable[143] = RGB(15,87,23);
	colourTable[144] = RGB(19,91,23);
	colourTable[145] = RGB(19,95,23);
	colourTable[146] = RGB(23,99,23);
	colourTable[147] = RGB(27,103,23);
	colourTable[148] = RGB(31,107,27);
	colourTable[149] = RGB(35,111,31);
	colourTable[150] = RGB(39,111,31);
	colourTable[151] = RGB(43,115,35);
	colourTable[152] = RGB(47,119,39);
	colourTable[153] = RGB(51,123,39);
	colourTable[154] = RGB(55,127,43);
	colourTable[155] = RGB(63,131,47);
	colourTable[156] = RGB(67,135,47);
	colourTable[157] = RGB(71,135,51);
	colourTable[158] = RGB(75,139,55);
	colourTable[159] = RGB(83,143,59);
	colourTable[160] = RGB(87,147,59);
	colourTable[161] = RGB(91,151,67);
	colourTable[162] = RGB(99,155,67);
	colourTable[163] = RGB(103,159,71);
	colourTable[164] = RGB(107,159,75);
	colourTable[165] = RGB(115,163,79);
	colourTable[166] = RGB(119,167,83);
	colourTable[167] = RGB(127,171,87);
	colourTable[168] = RGB(131,175,91);
	colourTable[169] = RGB(135,179,95);
	colourTable[170] = RGB(143,183,99);
	colourTable[171] = RGB(147,183,103);
	colourTable[172] = RGB(155,187,107);
	colourTable[173] = RGB(159,191,111);
	colourTable[174] = RGB(167,195,119);
	colourTable[175] = RGB(171,199,123);
	colourTable[176] = RGB(175,203,127);
	colourTable[177] = RGB(183,207,131);
	colourTable[178] = RGB(187,207,135);
	colourTable[179] = RGB(195,211,143);
	colourTable[180] = RGB(199,215,147);
	colourTable[181] = RGB(203,219,151);

	pDC = this->GetDC() ;

	// work out screen size and colour depth

	screenWidth  = pDC->GetDeviceCaps (HORZRES);

	screenHeight = pDC->GetDeviceCaps (VERTRES);
	
	screenBpp    = pDC->GetDeviceCaps (BITSPIXEL);

	// create master palette & palettize if screen in 256-colour mode 

	CDib dummyDib ;

	int res ;

	res = dummyDib.makePicture ( 1 , 1 , colourTable ) ;

	res = dummyDib.makePalette ( &masterPalette ) ;

	if ( screenBpp == 8 )
	{
		// convert to an identity palette

		for ( i = 0 ; i < 256 ; i++ )
			remap[i] = 0 ;

		osb.identityPalette ( &masterPalette , pDC ) ;

		for ( i = 0 ; i < 256 ; i++ )
			remap[i] = masterPalette.GetNearestPaletteIndex(colourTable[i]);
	}
	else
		for ( i = 0 ; i < 256 ; i++ ) 
			remap[i] = i ;

	// set up the DIB section osb, same size as the preview window

	CRect boundingRect ;

	GetClientRect ( &boundingRect ) ;

	frameRate  = theApp.GetProfileInt("Config","Frame Rate", 10) ;

	maxPlasma  = theApp.GetProfileInt("Config" , "Max Plasma Size" , 200 ) ;

	minPlasma  = theApp.GetProfileInt("Config" , "Min Plasma Size" , 100 );

	drift      = (float)((int)theApp.GetProfileInt("Config" , "Drift Rate" , 2 ))/10.0 ;

	plasmaSpeed = (float)(theApp.GetProfileInt("Config" , "Plasma Speed" , 41 )) / 10.0 ;

	// adjust plasma size to be proportional to window

	float fVal ;
	fVal = (float)maxPlasma / ((float)screenWidth / (float)(boundingRect.right - boundingRect.left)) ;

    maxPlasma = (int)fVal ;

	fVal = (float)minPlasma / ((float)screenWidth / (float)(boundingRect.right - boundingRect.left)) ;

    minPlasma = (int)fVal ;

	//maxPlasma /= (screenWidth / (boundingRect.right - boundingRect.left)) ;
	
	//minPlasma /= (screenWidth / (boundingRect.right - boundingRect.left));
	
	minPlasma = (minPlasma + 3 ) & ~3 ;
	maxPlasma = (maxPlasma + 3 ) & ~3 ;

	if ( maxPlasma < 4 )
		maxPlasma = 4 ;
	if ( minPlasma < 4 )
		minPlasma = 4 ;
	
	if ( minPlasma > maxPlasma ) 
	{
		int save ;
		save = maxPlasma ;
		maxPlasma = minPlasma ;
		minPlasma = save ;
	}

	if ( frameRate < 1 )
		frameRate = 1 ;
	
	cycleNum = minPlasma ;
	cycleUp = true ;

	osb.makeDibSection      ( boundingRect.right - boundingRect.left ,
                              boundingRect.bottom - boundingRect.top ,
  						      8 ,
							  pDC ,
							  &masterPalette ,
							  (screenBpp == 8 ) ) ;

	osb.setBgColour ( RGB(0,0,0) , 
	                  &masterPalette ) ;

	osb.bgFill () ;

	ReleaseDC(pDC) ;

	return 0;
}

void CPreviewWnd::OnTimer(UINT nIDEvent) 
{
	CRect boundingRect ;

	GetClientRect ( &boundingRect ) ;

	// fill in osb with next frame of plasma

	if ( minPlasma == maxPlasma )
		cycleNum = maxPlasma ;
	else if ( cycleUp ) 
	{
		if ( cycleNum >= maxPlasma || 
			 cycleNum >= boundingRect.right - boundingRect.left )
		{
			cycleUp = false ;
			cycleNum -= 1 ;
		}
		else
			cycleNum += 1 ;
	}
	else 
	{
		if ( cycleNum <= minPlasma )
		{
			cycleUp = true ;
			cycleNum += 1 ;
		}
		else
			cycleNum -= 1 ;
	}

	CDC * pDC = GetDC() ;

	drawPlasma ( pDC , cycleNum ) ;

	ReleaseDC (pDC) ;
	
	CWnd::OnTimer(nIDEvent);
}

void CPreviewWnd::OnPaletteChanged(CWnd* pFocusWnd) 
{
	CWnd::OnPaletteChanged(pFocusWnd);
	
	if ( pFocusWnd != this ) 
	{
		if ( screenBpp == 8 )
		{
			CDC * pDC = GetDC() ;
			pDC->SelectPalette(&masterPalette,FALSE);
			int i = pDC->RealizePalette() ;        // returns number of colours
			                                       // that were remapped
			if ( i > 0 )
			{
				// redraw the screen, so that colours are mapped properly
				CRect fullRect ;
				fullRect.SetRect ( 0 , 0 , osb.width , 
					                       osb.height ) ;

				osb.draw ( fullRect , fullRect , pDC , NULL ,
				           PALOP_FOREGROUND , &masterPalette ) ;
			}

			ReleaseDC(pDC);
			
		}
		
	}
	
}

BOOL CPreviewWnd::OnQueryNewPalette() 
{
	if ( screenBpp == 8)
	{
		CDC * pDC = GetDC() ;
		pDC->SelectPalette(&masterPalette,FALSE);
		int i = pDC->RealizePalette() ;        // returns number of colours
		                                       // that were remapped
		if ( i > 0 )
		{
			// redraw the screen, so that colours are mapped properly
			CRect fullRect ;
			fullRect.SetRect ( 0 , 0 , osb.width , 
				                       osb.height ) ;
			osb.draw ( fullRect , fullRect , pDC , NULL ,
 			           PALOP_FOREGROUND , &masterPalette ) ;
		}

		ReleaseDC(pDC);

		return i ;
			
	}
	else	
		return CWnd::OnQueryNewPalette();
}

void CPreviewWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CRect paintRect ( &dc.m_ps.rcPaint ) ;

	osb.draw ( paintRect , paintRect , &dc , NULL ,
 	           PALOP_FOREGROUND , &masterPalette ) ;
	
	// Do not call CWnd::OnPaint() for painting messages
}

void CPreviewWnd::drawPlasma ( CDC * pDC , int plasma_size)
{
	int i , j , k ;
	float value ;

	int byteWidth ;

	int * xbuffer  , * ybuffer ;

	xbuffer = (int*)malloc(plasma_size * sizeof(int)) ;
	ybuffer = (int*)malloc(plasma_size * sizeof(int)) ;

	angle1bak = angle1 ;
	angle2bak = angle2 ;
	angle3bak = angle3 ;

	// do horizontal graph

	for ( i = 0 ; i < plasma_size ; i++ )
	{
		value = 16.0*sin(angle1) + 8.0*sin(angle2) + 4.0*sin(angle3) ; // 16,8,4

		xbuffer[i] = (int)value ; // * 3)>>1;

		angle1 += 6.284/plasma_size;
		angle2 += 2*6.284/plasma_size;
		angle3 += 4*6.284/plasma_size ;
	}

	angle1 = angle1bak - ((1*6.284/320)*plasmaSpeed) ; // 1
	angle2 = angle2bak + ((3*6.284/320)*plasmaSpeed) ; // 3
	angle3 = angle3bak + ((2*6.284/320)*plasmaSpeed) ; // 2

	angle4bak = angle4 ;
	angle5bak = angle5 ;

	for ( i = 0 ; i < plasma_size ; i++ )
	{
		value = 16.0*sin(angle4) + 8.0*sin(angle5) ;

		ybuffer[i] = (int)value ;

		angle4 += 6.284/plasma_size;
		angle5 += 2*6.284/plasma_size ;
	}

	angle4 = angle1bak + ((3*6.284/320)*plasmaSpeed) ;  // 3
	angle5 = angle2bak + ((5*6.284/320)*plasmaSpeed) ;  // 5

	// fill in the plasma

	//::GdiFlush() ;

	byteWidth = ( osb.width + 3 ) & ~3 ;
	BYTE * pPix = osb.pPixels + 
		            (osb.height - plasma_size)*byteWidth ;

	for ( j = 0 ; j < plasma_size ; j++ )
	{
		k = ybuffer[j] ;

		if ( screenBpp == 8 )
			for ( i = 0 ; i < plasma_size ; i++ ) 
			{
				*(pPix + i + byteWidth*j) = remap[128 + k + xbuffer[i]] ;
			}
		else
			for ( i = 0 ; i < plasma_size ; i++ ) 
			{
				*(pPix + i + byteWidth*j) = 128 + k + xbuffer[i] ;
			}
	}

	free (xbuffer) ;
	free (ybuffer) ;

	// Copy plasma repeatedly in the osb, to tile it. 

	int numAcross = int(osb.width / plasma_size) + 1 ;
	int numDown   = int(osb.height / plasma_size) + 1 ;

	int vert , horz ;

	for ( vert = 0 ; vert < numDown ; vert++ ) 
		for ( horz = 0 ; horz < numAcross ; horz++ )
		{
			if ( vert > 0 || horz > 0 )
				osb.solidMerge ( horz*plasma_size , vert*plasma_size ,
					osb.pBmpInfoHdr ,
					osb.pPixels ,
					0 , 0 , 
					plasma_size , plasma_size , 
					false ) ;
		}

	CRect fullRect ;
	fullRect.SetRect ( 0 , 0 , osb.width , 
		                       osb.height ) ;
	//::GdiFlush() ;
	osb.draw ( fullRect , fullRect , pDC , NULL ,
		                   PALOP_FOREGROUND , &masterPalette ) ;

	angle1 -= drift ;
	angle2 -= drift ;
	angle3 -= drift ;
	angle4 -= drift ;
	angle5 -= drift ;

	if ( angle1 < 0 ) 
		angle1 += 6.284 ;
	else if ( angle1 > 6.283 )
		angle1 -= 6.284 ;
	if ( angle2 < 0 ) 
		angle2 += 6.284 ;
	else if ( angle2 > 6.283 )
		angle2 -= 6.284 ;
	if ( angle3 < 0 ) 
		angle3 += 6.284 ;
	else if ( angle3 > 6.283 )
		angle3 -= 6.284 ;
	if ( angle4 < 0 ) 
		angle4 += 6.284 ;
	else if ( angle4 > 6.283 )
		angle4 -= 6.284 ;
	if ( angle5 < 0 ) 
		angle5 += 6.284 ;
	else if ( angle5 > 6.283 )
		angle5 -= 6.284 ;
}
