// SaverWnd.cpp : implementation file
//

#include "stdafx.h"
#include "plasma.h"
#include "SaverWnd.h"

#include "math.h"

extern CPlasmaApp theApp ;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define THRESHOLD 3


/////////////////////////////////////////////////////////////////////////////
// CSaverWnd

CSaverWnd::CSaverWnd()
{
	m_iTimer = 0 ;

	askingPassword = false ;

	srand(::GetTickCount()) ;

	OSVERSIONINFO  osVersion ;

	osVersion.dwOSVersionInfoSize = sizeof(OSVERSIONINFO) ;

	if ( ::GetVersionEx ( &osVersion ) )
	{
		isWin95 = ( osVersion.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS ) ;
	}

	angle1 = 0 ;
	angle2 = 0 ;
	angle3 = 0 ;
	angle4 = 0 ;
	angle5 = 0 ;
	angle1bak = 0 ;
	angle2bak = 0 ;
	angle3bak = 0 ;
	angle4bak = 0 ;
	angle5bak = 0 ;




}

CSaverWnd::~CSaverWnd()
{
}


BEGIN_MESSAGE_MAP(CSaverWnd, CWnd)
	//{{AFX_MSG_MAP(CSaverWnd)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_TIMER()
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	ON_WM_PAINT()
	ON_WM_SYSCOMMAND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSaverWnd message handlers

BOOL CSaverWnd::Create() 
{
    BOOL bRes ;

	/*
	// Register a class with no cursor

    const char* pszClassName 
        = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_SAVEBITS|CS_DBLCLKS,
                              ::LoadCursor(AfxGetResourceHandle(),
                                           MAKEINTRESOURCE(IDC_NULLCURSOR)));

   */
	const char* pszClassName =
		   AfxRegisterWndClass(0,0,0,0) ;

    // Create the window
    bRes = CWnd::CreateEx(
#ifdef _DEBUG		
		                  0 , 
#else
						  WS_EX_TOPMOST,
#endif
                          pszClassName,
                          "",
                          WS_POPUP | WS_VISIBLE,
                          0, 0,
                          ::GetSystemMetrics(SM_CXSCREEN),
                          ::GetSystemMetrics(SM_CYSCREEN),
                          NULL,
                          NULL);

	if ( bRes ) 
	{
	    m_iTimer = SetTimer(1, 1000 / frameRate , NULL);
	}

	return bRes ;

}

BOOL CSaverWnd::DestroyWindow() 
{
	if ( m_iTimer != 0 )
	{
		KillTimer(1) ;
	}

	::ShowCursor(TRUE) ;
	
	return CWnd::DestroyWindow();
}

void CSaverWnd::PostNcDestroy() 
{
    delete this;	
}

LRESULT CSaverWnd::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
    static BOOL     gotPos = FALSE;
    static POINT    cursorPos ;
    POINT           newPos;
	int             xDiff , yDiff ;

    switch (message)
	{
    case WM_MOUSEMOVE:
        if(!gotPos) 
		{   
			GetCursorPos(&cursorPos);
            gotPos = TRUE;
        } 
		else 
		{   
			GetCursorPos(&newPos);
            xDiff = newPos.x - cursorPos.x ; 
			if (xDiff < 0) 
				xDiff *= -1;
            
			yDiff = newPos.y - cursorPos.y ; 
			if (yDiff < 0) 
				yDiff *= -1;
            
			if ( (xDiff + yDiff) > THRESHOLD ) 
			{	
				if ( !isWin95 || askPassword() ) 
					PostMessage(WM_CLOSE, 0, 0l);
				else
					gotPos = false ;
            }
        }
        break;

    case WM_LBUTTONDOWN:
    case WM_MBUTTONDOWN:
    case WM_RBUTTONDOWN:

	
    case WM_KEYDOWN:
    case WM_SYSKEYDOWN:

		if ( !isWin95 || askPassword() ) 
			PostMessage(WM_CLOSE, 0, 0l);
		else
			gotPos = false ;
        break;
    }
	
	return CWnd::WindowProc(message, wParam, lParam);
}

int CSaverWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	while ( ::ShowCursor(FALSE) >= 0 ) ;

	CDC * pDC ;

	int colourTable[256] ;

	// set up RGB colour table 

	// Use the palette from the PLASMA demo

	int i ;
	for ( i = 0 ; i < 256 ; i++ ) 
		colourTable[i] = 0 ;

	colourTable[10] = RGB (237,225,225) ;
	colourTable[11] = RGB (239,227,227);
	colourTable[12] = RGB (241,229,229) ;
	colourTable[13] = RGB (243,231,231) ;
	colourTable[14] = RGB (245,235,235) ;
	colourTable[15] = RGB (247,239,239) ;
	colourTable[16] = RGB (249,243,243) ;
	colourTable[17] = RGB (251,247,247) ;
	colourTable[18] = RGB (253,251,251) ;
	colourTable[19] = RGB (255,255,255) ;
	colourTable[20] = RGB (249,251,251) ;
	colourTable[21] = RGB (243,247,247);
	colourTable[22] = RGB (237,245,243) ;
	colourTable[23] = RGB (231,243,239);
	colourTable[24] = RGB (227,241,235) ;
	colourTable[25] = RGB (223,239,231);
	colourTable[26] = RGB (219,237,227) ;
	colourTable[27] = RGB (215,235,223) ;
	colourTable[28] = RGB (211,233,219) ;
	colourTable[29] = RGB (207,231,215) ;
	colourTable[30] = RGB (201,229,213) ;
	colourTable[31] = RGB (195,227,211);
	colourTable[32] = RGB (191,225,207) ;
	colourTable[33] = RGB (187,223,203);
	colourTable[34] = RGB (183,219,199) ;
	colourTable[35] = RGB (179,215,195);
	colourTable[36] = RGB (175,213,193) ;
	colourTable[37] = RGB (171,211,191);
	colourTable[38] = RGB (167,209,187) ;
	colourTable[39] = RGB (163,207,183);
	colourTable[40] = RGB (159,205,181) ;
	colourTable[41] = RGB (155,203,179);
	colourTable[42] = RGB (151,201,175) ;
	colourTable[43] = RGB (147,199,171);
	colourTable[44] = RGB (143,197,167) ;
	colourTable[45] = RGB (139,195,163);
	colourTable[46] = RGB (137,193,161) ;
	colourTable[47] = RGB (135,191,159);
	colourTable[48] = RGB (131,187,155) ;
	colourTable[49] = RGB (127,183,151);
	colourTable[50] = RGB (123,181,149) ;
	colourTable[51] = RGB (119,179,147);
	colourTable[52] = RGB (115,177,143) ;
	colourTable[53] = RGB (111,175,139);
	colourTable[54] = RGB (109,173,137) ;
	colourTable[55] = RGB (107,171,135);
	colourTable[56] = RGB (103,169,133) ;
	colourTable[57] = RGB ( 99,167,131);
	colourTable[58] = RGB ( 95,165,127) ;
	colourTable[59] = RGB ( 91,163,123);
	colourTable[60] = RGB ( 89,161,121) ;
	colourTable[61] = RGB ( 87,159,119);
	colourTable[62] = RGB ( 85,155,115) ;
	colourTable[63] = RGB ( 83,151,111);
	colourTable[64] = RGB ( 79,149,109) ;
	colourTable[65] = RGB ( 75,147,107);
	colourTable[66] = RGB ( 73,145,105) ;
	colourTable[67] = RGB ( 71,143,103);
	colourTable[68] = RGB ( 67,141,101) ;
	colourTable[69] = RGB ( 63,139, 99);
	colourTable[70] = RGB ( 61,137, 97) ;
	colourTable[71] = RGB ( 59,135, 95);
	colourTable[72] = RGB ( 57,133, 91) ;
	colourTable[73] = RGB ( 55,131, 87);
	colourTable[74] = RGB ( 53,129, 85) ;
	colourTable[75] = RGB ( 51,127, 83);
	colourTable[76] = RGB ( 49,123, 81) ;
	colourTable[77] = RGB ( 47,119, 79);
	colourTable[78] = RGB ( 45,117, 77) ;
	colourTable[79] = RGB ( 43,115, 75);
	colourTable[80] = RGB ( 41,113, 73) ;
	colourTable[81] = RGB ( 39,111, 71);
	colourTable[82] = RGB ( 37,109, 69) ;
	colourTable[83] = RGB ( 35,107, 67);
	colourTable[84] = RGB ( 33,105, 65) ;
	colourTable[85] = RGB ( 31,103, 63);
	colourTable[86] = RGB ( 29,101, 61) ;
	colourTable[87] = RGB ( 27, 99, 59);
	colourTable[88] = RGB ( 25, 97, 57) ;
	colourTable[89] = RGB ( 23, 95, 55);
	colourTable[90] = RGB ( 21, 91 ,53) ;
	colourTable[91] = RGB ( 19, 87, 51);
	colourTable[92] = RGB ( 17, 85, 49) ;
	colourTable[93] = RGB ( 15, 83, 47);
	colourTable[94] = RGB ( 15, 81, 45) ;
	colourTable[95] = RGB ( 15, 79, 43);
	colourTable[96] = RGB ( 13, 77, 41) ;
	colourTable[97] = RGB ( 11, 75, 39);
	colourTable[98] = RGB ( 11, 73, 37) ;
	colourTable[99] = RGB ( 11, 71, 35);
	colourTable[100] =RGB (  9, 69 ,35) ;
	colourTable[101] =RGB (  7, 67, 35);
	colourTable[102] =RGB (  7, 65 ,33) ;
	colourTable[103] =RGB (  7, 63, 31);
	colourTable[104] =RGB (  7, 59 ,29) ;
	colourTable[105] =RGB (  7, 55, 27);
	colourTable[106] =RGB (  0, 53 ,25 ) ;
	colourTable[107] =RGB (  0, 51, 23);
	colourTable[108] =RGB (  0, 49 ,23 ) ;
	colourTable[109] =RGB (  0, 47, 23);
	colourTable[110] =RGB (  0, 45, 21 ) ;
	colourTable[111] =RGB (  0, 43, 19);
	colourTable[112] =RGB (  0, 41 ,17 ) ;
	colourTable[113] =RGB (  0, 39, 15);
	colourTable[114] =RGB (  0, 37 ,15 ) ;
	colourTable[115] =RGB (  0, 35, 15);
	colourTable[116] =RGB (  0, 35 ,15 ) ;
	colourTable[117] =RGB (  0, 35, 15);
	colourTable[118] =RGB (  0, 37, 15) ;
	colourTable[119] =RGB (  0, 39, 15);
	colourTable[120] =RGB (  0, 41 ,15 ) ;
	colourTable[121] =RGB (  0, 43, 15);
	colourTable[122] =RGB (  0, 45, 15) ;
	colourTable[123] =RGB (  0, 47, 15);
	colourTable[124] =RGB (  0, 49 ,17 ) ;
	colourTable[125] =RGB (  0, 51, 19);
	colourTable[126] =RGB (  0, 53, 19 ) ;
	colourTable[127] =RGB (  0, 55, 19);
	colourTable[128] =RGB (  0, 57, 19) ;
	colourTable[129] =RGB (  0, 59, 19);
	colourTable[130] =RGB (  3, 59 ,19 ) ;
	colourTable[131] =RGB (  7, 59, 19);
	colourTable[132] =RGB (  7, 61 ,19 ) ;
	colourTable[133] =RGB (  7, 63, 19);
	colourTable[134] =RGB (  7, 65, 19) ;
	colourTable[135] =RGB (  7, 67, 19);
	colourTable[136] =RGB (  7, 69, 19 ) ;
	colourTable[137] =RGB (  7, 71, 19);
	colourTable[138] =RGB (  9, 73, 19 ) ;
	colourTable[139] =RGB ( 11, 75, 19);
	colourTable[140] =RGB ( 11, 77 ,21 ) ;
	colourTable[141] =RGB ( 11, 79, 23);
	colourTable[142] =RGB ( 11, 81, 23 ) ;
	colourTable[143] =RGB ( 11, 83, 23);
	colourTable[144] =RGB ( 13, 85, 23 ) ;
	colourTable[145] =RGB ( 15, 87, 23);
	colourTable[146] =RGB ( 15, 87 ,23 ) ;
	colourTable[147] =RGB ( 15, 87, 23);
	colourTable[148] =RGB ( 17, 89 ,23 ) ;
	colourTable[149] =RGB ( 19, 91, 23);
	colourTable[150] =RGB ( 19, 93, 23) ;
	colourTable[151] =RGB ( 19, 95, 23);
	colourTable[152] =RGB ( 21, 97, 23 ) ;
	colourTable[153] =RGB ( 23, 99, 23);
	colourTable[154] =RGB ( 25,101, 23) ;
	colourTable[155] =RGB ( 27,103, 23);
	colourTable[156] =RGB ( 29,105 ,25 ) ;
	colourTable[157] =RGB ( 31,107, 27);
	colourTable[158] =RGB ( 33,109, 29) ;
	colourTable[159] =RGB ( 35,111, 31);
	colourTable[160] =RGB ( 37,111, 31) ;
	colourTable[161] =RGB ( 39,111, 31);
	colourTable[162] =RGB ( 41,113 ,33 ) ;
	colourTable[163] =RGB ( 43,115, 35);
	colourTable[164] =RGB ( 45,117, 37) ;
	colourTable[165] =RGB ( 47,119, 39);
	colourTable[166] =RGB ( 49,121, 39) ;
	colourTable[167] =RGB ( 51,123, 39);
	colourTable[168] =RGB ( 53,125, 41 ) ;
	colourTable[169] =RGB ( 55,127, 43);
	colourTable[170] =RGB ( 59,129 ,45 ) ;
	colourTable[171] =RGB ( 63,131, 47);
	colourTable[172] =RGB ( 65,133, 47) ;
	colourTable[173] =RGB ( 67,135, 47);
	colourTable[174] =RGB ( 69,135, 49 ) ;
	colourTable[175] =RGB ( 71,135, 51);
	colourTable[176] =RGB ( 73,137, 53) ;
	colourTable[177] =RGB ( 75,139, 55);
	colourTable[178] =RGB ( 79,141, 57) ;
	colourTable[179] =RGB ( 83,143, 59);
	colourTable[180] =RGB ( 85,145, 59) ;
	colourTable[181] =RGB ( 87,147, 59);
	colourTable[182] =RGB ( 89,149, 63 ) ;
	colourTable[183] =RGB ( 91,151, 67);
	colourTable[184] =RGB ( 95,153, 67) ;
	colourTable[185] =RGB ( 99,155, 67);
	colourTable[186] =RGB (101,157, 69 ) ;
	colourTable[187] =RGB (103,159, 71);
	colourTable[188] =RGB (105,159, 73 ) ;
	colourTable[189] =RGB (107,159, 75);
	colourTable[190] =RGB (111,161, 77 ) ;
	colourTable[191] =RGB (115,163, 79);
	colourTable[192] =RGB (117,165, 81 ) ;
	colourTable[193] =RGB (119,167, 83);
	colourTable[194] =RGB (123,169 ,85 ) ;
	colourTable[195] =RGB (127,171, 87);
	colourTable[196] =RGB (129,173 ,89 ) ;
	colourTable[197] =RGB (131,175, 91);
	colourTable[198] =RGB (133,177 ,93 ) ;
	colourTable[199] =RGB (135,179, 95);
	colourTable[200] =RGB (139,181 ,97 ) ;
	colourTable[201] =RGB (143,183, 99);
	colourTable[202] =RGB (145,183,101 ) ;
	colourTable[203] =RGB (147,183,103);
	colourTable[204] =RGB (151,185,105 ) ;
	colourTable[205] =RGB (155,187,107);
	colourTable[206] =RGB (157,189,109 ) ;
	colourTable[207] =RGB (159,191,111);
	colourTable[208] =RGB (163,193,115 ) ;
	colourTable[209] =RGB (167,195,119);
	colourTable[210] =RGB (169,197,121 ) ;
	colourTable[211] =RGB (171,199,123);
	colourTable[212] =RGB (173,201,125 ) ;
	colourTable[213] =RGB (175,203,127);
	colourTable[214] =RGB (179,205,129 ) ;
	colourTable[215] =RGB (183,207,131);
	colourTable[216] =RGB (185,207,133) ;
	colourTable[217] =RGB (187,207,135);
	colourTable[218] =RGB (191,209,139 ) ;
	colourTable[219] =RGB (195,211,143);
	colourTable[220] =RGB (197,213,145 ) ;
	colourTable[221] =RGB (199,215,147);
	colourTable[222] =RGB (201,217,149 ) ;
	colourTable[223] =RGB (203,219,151);
	colourTable[224] =RGB(205,221,153 );

	pDC = this->GetDC() ;
	
	// work out screen size and colour depth

	screenWidth  = pDC->GetDeviceCaps (HORZRES);

	screenHeight = pDC->GetDeviceCaps (VERTRES);
	
	screenBpp    = pDC->GetDeviceCaps (BITSPIXEL);

	
	frameRate  = theApp.GetProfileInt("Config","Frame Rate", 10) ;

	maxPlasma  = theApp.GetProfileInt("Config" , "Max Plasma Size" , 200 ) ;

	minPlasma  = theApp.GetProfileInt("Config" , "Min Plasma Size" , 100 );

	drift      = (float)((int)theApp.GetProfileInt("Config" , "Drift Rate" , 2 ))/10.0 ;

	plasmaSpeed = (float)(theApp.GetProfileInt("Config" , "Plasma Speed" , 41 )) / 10.0 ;

	minPlasma = (minPlasma + 3 ) & ~3 ;
	maxPlasma = (maxPlasma + 3 ) & ~3 ;

	if ( minPlasma > maxPlasma ) 
	{
		int save ;
		save = maxPlasma ;
		maxPlasma = minPlasma ;
		minPlasma = save ;
	}

	if ( frameRate < 1 )
		frameRate = 1 ;

	cycleNum = minPlasma ;
	cycleUp = true ;

	// create master palette 

	CDib dummyDib ;

	int res ;

	res = dummyDib.makePicture ( 1 , 1 , colourTable ) ;

	res = dummyDib.makePalette ( &masterPalette) ;

	if ( screenBpp == 8 )
	{
		// convert to an identity palette if in 256-colour mode

		for ( i = 0 ; i < 256 ; i++ )
			remap[i] = 0 ;

		osb.identityPalette ( &masterPalette , pDC ) ;

		for ( i = 0 ; i < 256 ; i++ )
			remap[i] = masterPalette.GetNearestPaletteIndex(colourTable[i]);
	}
	else
		for ( i = 0 ; i < 256 ; i++ ) 
			remap[i] = i ;

	// set up the DIB section osb, same size as the full window

	osb.makeDibSection ( screenWidth ,
	                     screenHeight ,
	    				 8 , 
						 pDC ,
						 &masterPalette ,
						 (screenBpp == 8) // palettize if in 256-colour mode
					   ) ;

	osb.setBgColour ( RGB(0,0,0) , 
		              &masterPalette) ;

	osb.bgFill () ;

	ReleaseDC(pDC) ;

    startTime = CTime::GetCurrentTime() ;
	
	return 0;
}

BOOL CSaverWnd::OnEraseBkgnd(CDC* pDC) 
{
	RECT winSize ;

	pDC->GetClipBox( &winSize) ;

	pDC->FillSolidRect ( &winSize , RGB(0,0,0) ) ;

	drawPlasma ( pDC , cycleNum ) ;

	return TRUE ;
}

void CSaverWnd::OnTimer(UINT nIDEvent) 
{
	// fill in osb with next frame of plasma

	if ( minPlasma == maxPlasma )
		cycleNum = maxPlasma ;
	else if ( cycleUp ) 
	{
		if ( cycleNum >= maxPlasma || cycleNum >= screenWidth )
		{
			cycleUp = false ;
			cycleNum -= 4 ;
		}
		else
			cycleNum += 4 ;
	}
	else 
	{
		if ( cycleNum <= minPlasma )
		{
			cycleUp = true ;
			cycleNum += 4 ;
		}
		else
			cycleNum -=4 ;
	}

	CDC * pDC = GetDC() ;

	drawPlasma ( pDC , cycleNum ) ;

	ReleaseDC (pDC) ;

	CWnd::OnTimer(nIDEvent);
}

void CSaverWnd::OnPaletteChanged(CWnd* pFocusWnd) 
{
	CWnd::OnPaletteChanged(pFocusWnd);
	
	if ( pFocusWnd != this ) 
	{
		if ( screenBpp == 8 )
		{
			CDC * pDC = GetDC() ;
			pDC->SelectPalette(&masterPalette,FALSE);
			int i = pDC->RealizePalette() ;        // returns number of colours
			                                       // that were remapped
			if ( i > 0 )
			{
				// redraw the screen, so that colours are mapped properly
				CRect fullRect ;
				fullRect.SetRect ( 0 , 0 , osb.width , 
					                       osb.height ) ;

				osb.draw ( fullRect , fullRect , pDC , NULL ,
				           PALOP_FOREGROUND , &masterPalette ) ;
			}

			ReleaseDC(pDC);
			
		}
	}	
}

BOOL CSaverWnd::OnQueryNewPalette() 
{
	if ( screenBpp == 8)
	{
		CDC * pDC = GetDC() ;
		pDC->SelectPalette(&masterPalette,FALSE);
		int i = pDC->RealizePalette() ;        // returns number of colours
		                                       // that were remapped
		if ( i > 0 )
		{
			// redraw the screen, so that colours are mapped properly
			CRect fullRect ;
			fullRect.SetRect ( 0 , 0 , osb.width , 
				                       osb.height ) ;
			osb.draw ( fullRect , fullRect , pDC , NULL ,
 	                   PALOP_FOREGROUND , &masterPalette ) ;
		}

		ReleaseDC(pDC);

		return i ;
			
	}
	else	
		return CWnd::OnQueryNewPalette();
}

bool CSaverWnd::askPassword ()
{
	if ( ! this->isWin95 ) 
		return true ;

	// don't ask for password if within 10 seconds of starting

	CTime currTime ;
	CTimeSpan elapsedTime ;

	currTime = CTime::GetCurrentTime() ;

	elapsedTime = currTime - startTime ;

	if ( elapsedTime.GetTotalSeconds() < 5 ) 
		return true ;

	askingPassword = true ;

	bool result = true ;

	HKEY hKey ;
	DWORD usePW ;
	DWORD valType ;
	DWORD valSize = sizeof(DWORD) ;

	if ( ::RegOpenKeyEx(HKEY_CURRENT_USER , "Control Panel\\Desktop" , 0 ,
		                KEY_READ , &hKey ) )
	{
		::RegQueryValueEx ( hKey , "ScreenSaveUsePassword" , NULL , 
			            &valType , (LPBYTE)&usePW , &valSize ) ;
		::RegCloseKey ( hKey ) ;
	}

	if ( usePW != 0 )
	{
		HINSTANCE hPasswordCpl = ::LoadLibrary("PASSWORD.CPL") ;
		if ( hPasswordCpl != NULL )
		{
			typedef BOOL (WINAPI *VERIFYSCREENSAVEPWD)(HWND) ;
			VERIFYSCREENSAVEPWD VerifyScreenSavePwd =
				(VERIFYSCREENSAVEPWD)GetProcAddress(hPasswordCpl,
				         "VerifyScreenSavePwd" ) ;
			int prev ;
			SystemParametersInfo ( SPI_SCREENSAVERRUNNING , 1 , &prev , 0 ) ;
            ::ShowCursor(TRUE);
			result = ( VerifyScreenSavePwd(this->m_hWnd) == TRUE ) ;
			::ShowCursor(FALSE) ;
			SystemParametersInfo ( SPI_SCREENSAVERRUNNING , 0 , &prev , 0 ) ;
		}
		::FreeLibrary(hPasswordCpl);
	}

	askingPassword = false ;

	return result ;
}

void CSaverWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CRect paintRect ( &dc.m_ps.rcPaint ) ;

	osb.draw ( paintRect , paintRect , &dc , NULL ,
	              PALOP_FOREGROUND , &masterPalette ) ;
	
	// Do not call CWnd::OnPaint() for painting messages
}

void CSaverWnd::drawPlasma ( CDC * pDC , int plasma_size)
{
	int i , j , k ;
	float value ;

	int byteWidth ;

	int * xbuffer  , * ybuffer ;

	xbuffer = (int*)malloc(plasma_size * sizeof(int)) ;
	ybuffer = (int*)malloc(plasma_size * sizeof(int)) ;

	angle1bak = angle1 ;
	angle2bak = angle2 ;
	angle3bak = angle3 ;

	// do horizontal graph

	for ( i = 0 ; i < plasma_size ; i++ )
	{
		value = 32.0*sin(angle1) + 16.0*sin(angle2) + 8.0*sin(angle3) ; // 16,8,4

		xbuffer[i] = (int)value ; // * 3)>>1;

		angle1 += 6.284/plasma_size;
		angle2 += 2*6.284/plasma_size;
		angle3 += 4*6.284/plasma_size ;
	}

	angle1 = angle1bak - ((1*6.284/320)*plasmaSpeed) ; // 1
	angle2 = angle2bak + ((3*6.284/320)*plasmaSpeed) ; // 3
	angle3 = angle3bak + ((2*6.284/320)*plasmaSpeed) ; // 2

	angle4bak = angle4 ;
	angle5bak = angle5 ;

	for ( i = 0 ; i < plasma_size ; i++ )
	{
		value = 32.0*sin(angle4) + 16.0*sin(angle5) ;

		ybuffer[i] = (int)value ;

		angle4 += 6.284/plasma_size;
		angle5 += 2*6.284/plasma_size ;
	}

	angle4 = angle1bak + ((3*6.284/320)*plasmaSpeed) ;  // 3
	angle5 = angle2bak + ((5*6.284/320)*plasmaSpeed) ;  // 5

	// fill in the plasma

	::GdiFlush() ;
	byteWidth = ( osb.width + 3 ) & ~3 ;
	BYTE * pPix = osb.pPixels + 
		            (osb.height - plasma_size)*byteWidth ;

	for ( j = 0 ; j < plasma_size ; j++ )
	{
		k = ybuffer[j] ;

		if ( screenBpp == 8 )
			for ( i = 0 ; i < plasma_size ; i++ ) 
			{
				*(pPix + i + byteWidth*j) = remap[117 + k + xbuffer[i]] ;
			}
		else
			for ( i = 0 ; i < plasma_size ; i++ ) 
			{
				*(pPix + i + byteWidth*j) = 117 + k + xbuffer[i] ;
			}
	}

	free (xbuffer) ;
	free (ybuffer) ;

	// Copy plasma repeatedly in the osb, to tile it. 

	int numAcross = int(osb.width / plasma_size) + 1 ;
	int numDown   = int(osb.height / plasma_size) + 1 ;

	int vert , horz ;

	for ( vert = 0 ; vert < numDown ; vert++ ) 
		for ( horz = 0 ; horz < numAcross ; horz++ )
		{
			if ( vert > 0 || horz > 0 )
				osb.solidMerge ( horz*plasma_size , vert*plasma_size ,
					osb.pBmpInfoHdr ,
					osb.pPixels ,
					0 , 0 , 
					plasma_size , plasma_size , 
					false ) ;
		}

	CRect fullRect ;
	fullRect.SetRect ( 0 , 0 , osb.width , 
		                       osb.height ) ;
	::GdiFlush() ;
	osb.draw ( fullRect , fullRect , pDC , NULL ,
		                   PALOP_FOREGROUND , &masterPalette ) ;

	angle1 -= drift ;
	angle2 -= drift ;
	angle3 -= drift ;
	angle4 -= drift ;
	angle5 -= drift ;

	if ( angle1 < 0 ) 
		angle1 += 6.284 ;
	else if ( angle1 > 6.283 )
		angle1 -= 6.284 ;
	if ( angle2 < 0 ) 
		angle2 += 6.284 ;
	else if ( angle2 > 6.283 )
		angle2 -= 6.284 ;
	if ( angle3 < 0 ) 
		angle3 += 6.284 ;
	else if ( angle3 > 6.283 )
		angle3 -= 6.284 ;
	if ( angle4 < 0 ) 
		angle4 += 6.284 ;
	else if ( angle4 > 6.283 )
		angle4 -= 6.284 ;
	if ( angle5 < 0 ) 
		angle5 += 6.284 ;
	else if ( angle5 > 6.283 )
		angle5 -= 6.284 ;

}

void CSaverWnd::OnSysCommand(UINT nID, LPARAM lParam) 
{
	// don't start a second screen saver

    if ( nID != SC_SCREENSAVE ) 
		CWnd::OnSysCommand(nID, lParam);
}
