// plasma.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "plasma.h"

#include "previewWnd.h" 
#include "saverWnd.h"
#include "configDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlasmaApp

BEGIN_MESSAGE_MAP(CPlasmaApp, CWinApp)
	//{{AFX_MSG_MAP(CPlasmaApp)
	//}}AFX_MSG_MAP
	// Standard file based document commands
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlasmaApp construction

CPlasmaApp::CPlasmaApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPlasmaApp object

CPlasmaApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CPlasmaApp initialization

BOOL CPlasmaApp::InitInstance()
{
	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	bool isWin95 = false ;

	OSVERSIONINFO  osVersion ;

	osVersion.dwOSVersionInfoSize = sizeof(OSVERSIONINFO) ;

	if ( ::GetVersionEx ( &osVersion ) )
	{
		isWin95 = ( osVersion.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS ) ;
	}

	// Change the registry key under which our settings are stored.

	SetRegistryKey(_T("MRobinson"));

    // If the command line contains /s -s or s then just run as a 
    // screen saver.  If the command line is blank or contains 
    // /c -c or c then show the config dialog

	//{
	//	char msg[200] ;
	//	sprintf ( msg , "Call line params = %s  " , m_lpCmdLine ) ;
    //	AfxMessageBox ( msg , MB_OK , 0 ) ;
    //
	//}
	// 
	// If command line begins with "/p", it is a request for the preview
	// screen. The Window handle is written following the "/p".
	// 
	// If command line begins with "/a", it is a Windows 95/98 request to
	// change the screen saver password

	// Get first token

	char token[201] ;

	for ( int i = 0 ; i < 200 && i < strlen(m_lpCmdLine) && m_lpCmdLine[i] != ' ' 
		                               && m_lpCmdLine[i] != ':' ; i++ )
		token[i] = m_lpCmdLine[i] ;

	token[i] = '\0' ;


	if ( isWin95 && ( !strcmpi(token,"/a") || !strcmpi(token,"-a") || !strcmpi(token,"a")))
	{
		int iHandle = 0 ;
		if ( i < 200 && i < strlen(m_lpCmdLine) )
		{
			// skip spaces up to the number

			for ( ; i < 200 && i < strlen(m_lpCmdLine) && m_lpCmdLine[i] == ' ' ; i++ ) ;
			if ( i < 200 && i < strlen(m_lpCmdLine) ) 
			{
				for ( ; i < 200 && i < strlen(m_lpCmdLine) && m_lpCmdLine[i] >= '0'
					        && m_lpCmdLine[i] <= '9' ; i++ )
					iHandle = iHandle * 10 + m_lpCmdLine[i] - '0' ;
			}
		}
		// display "standard" screensaver password change screen

		HWND hParent = (iHandle == 0 ) ? ::GetForegroundWindow() : (HWND)iHandle ;

		// Load dynamically, because Windows NT doesn't have this

		HINSTANCE hMprDll = ::LoadLibrary("MPR.DLL") ;
		if ( hMprDll != NULL ) 
		{
			// dynamic call of standard screen saver password change screen

			typedef VOID (WINAPI *PWDCHANGEPASSWORDA)(LPSTR,HWND,UINT,UINT) ;
			PWDCHANGEPASSWORDA PwdChangePasswordA =
				(PWDCHANGEPASSWORDA)::GetProcAddress(hMprDll, "PwdChangePasswordA");
			if ( PwdChangePasswordA != NULL )
				PwdChangePasswordA("SCRSAVE", hParent, 0, 0 );
		}
		::FreeLibrary ( hMprDll ) ;

		return TRUE ;
	}
    else if (((!strcmpi(token,"/p") 
    || !strcmpi(token,"-p")) 
    || !strcmpi(token,"p"))) 
	{
		// display preview window

		// get window handle

		int iHandle = 0 ;

		if ( i < 200 && i < strlen(m_lpCmdLine) )
		{
			// skip spaces up to the number

			for ( ; i < 200 && i < strlen(m_lpCmdLine) && m_lpCmdLine[i] == ' ' 
				       && m_lpCmdLine[i] != ':' ; i++ ) ;
			if ( i < 200 && i < strlen(m_lpCmdLine) ) 
			{
				for ( ; i < 200 && i < strlen(m_lpCmdLine) && m_lpCmdLine[i] >= '0'
					        && m_lpCmdLine[i] <= '9' ; i++ )
					iHandle = iHandle * 10 + m_lpCmdLine[i] - '0' ;
			}
			HWND hWnd = (HWND)iHandle ;

			CPreviewWnd * pWnd = new CPreviewWnd ;
			pWnd->Create(hWnd);
			m_pMainWnd = pWnd;
			return TRUE ;
		}

		return FALSE ;		
	}
	else if (((!strcmpi(token,"/s") 
    || !strcmpi(token,"-s")) 
    || !strcmpi(token,"s"))) 
	{
        // Run as screen saver
        CSaverWnd* pWnd = new CSaverWnd;
        pWnd->Create();
        m_pMainWnd = pWnd;
	    return TRUE;
    } 
	else 
	{
        // Run the configuration dialog
        if(((!strcmpi(token,"/c") 
           || !strcmpi(token,"-c")) 
           || !strcmpi(token,"c"))) 
		{
		    // Run config with current window as parent
					// get window handle

			int iHandle = 0 ;

			if ( i < 200 && i < strlen(m_lpCmdLine) )
			{
				// skip spaces up to the number

				for ( ; i < 200 && i < strlen(m_lpCmdLine) && (m_lpCmdLine[i] == ' ' 
					       || m_lpCmdLine[i] == ':') ; i++ ) ;
				if ( i < 200 && i < strlen(m_lpCmdLine) ) 
				{
					for ( ; i < 200 && i < strlen(m_lpCmdLine) && m_lpCmdLine[i] >= '0'
						        && m_lpCmdLine[i] <= '9' ; i++ )
						iHandle = iHandle * 10 + m_lpCmdLine[i] - '0' ;
				}
			}
			
			HWND hWnd ;

			CWnd * pParent = NULL ;

			if ( iHandle > 0 )
			{
				hWnd = (HWND)iHandle ;
				pParent = CWnd::FromHandle(hWnd) ;
			}
			else
				pParent = CWnd::GetForegroundWindow() ;

			DoConfig(pParent) ; 
        } 
		else 
		{
		    // Run the config dlg with no parent
            DoConfig(NULL);
        }

        // Now just terminate
        return TRUE;
    }

	return TRUE;
}

void CPlasmaApp::DoConfig(CWnd* pParent)
{

    CConfigDlg dlg(pParent);

	int drift ;

    // Set up the current params
    dlg.m_frameRate  = GetProfileInt("Config","Frame Rate", 10) ;

	dlg.m_maxPlasma  = GetProfileInt("Config" , "Max Plasma Size" , 200 ) ;

	dlg.m_minPlasma  = GetProfileInt("Config" , "Min Plasma Size" , 100 );

	drift            = GetProfileInt("Config" , "Drift Rate" , 2 ) ;

	if ( drift >= 0 )
	{
		dlg.m_Drift = drift ;
		dlg.m_DriftUp = 0 ;
	}
	else
	{
		dlg.m_Drift = - drift ;
		dlg.m_DriftUp = 1 ;
	}

	dlg.m_PlasmaSpeed = GetProfileInt("Config" , "Plasma Speed" , 41 ) ;

    // Do the dialog
    if (dlg.DoModal() != IDOK) 
		return;

    drift = dlg.m_Drift ;
	if ( dlg.m_DriftUp > 0 )
		drift *= -1 ;

    WriteProfileInt("Config","Frame Rate", dlg.m_frameRate );
	WriteProfileInt("Config","Max Plasma Size", dlg.m_maxPlasma ) ;
	WriteProfileInt("Config", "Min Plasma Size" , dlg.m_minPlasma ) ;
	WriteProfileInt("Config", "Drift Rate" , drift ) ;
	WriteProfileInt("Config" , "Plasma Speed" , dlg.m_PlasmaSpeed ) ;
}
